//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gSelection, params;

function flock_togglePosted(dontShowDialog) {
    if ($('postOnline').checked) {
        if (!flock_getBoolPref('flock.favorites.askedAboutSharing') || !flock.favorites.service.webService) {
            if (!dontShowDialog) {
                flock.favorites.showSharingDialog ();
            }
            flock_setupSharingLevel();
            if (!flock.favorites.service.webService) {
                $('postOnline').removeAttribute('checked');
                return;
            }
        }

        $('shareLevel').removeAttribute('disabled');
    } else {
        $('shareLevel').setAttribute('disabled', "true");
    }
}

function flock_setupSharingLevel() {
    if (flock.favorites.service.webService && flock.favorites.supportsField('private')) {
        $('shareLevel').removeAttribute('hidden');
    }
    else {
        $('shareLevel').setAttribute('hidden', true);
    }
}

function flock_favoritesEditorLoad() {
    params = window.arguments[0];
    
    if (params.items) {
        gSelection = params.items[0];
    } 
    else {
        gSelection = params.item;
    }
        
    $('favUrl').value = gSelection['url'] || '';
    $('favName').value = gSelection['name'] || '';
    $('favDescription').value = gSelection['description'] || '';
    $('favTags').value = gSelection['tags'] || '';
    if (gSelection['local']) {
        $('postOnline').removeAttribute('checked');
    } else {
        $('postOnline').setAttribute('checked', true)
    }

    flock_togglePosted(true);
    flock_setupSharingLevel();

    if (gSelection['private']) {
        $('shareLevel').value = 'private';
    } else {
        $('shareLevel').value = 'public';
    }
    
    if (params.item) {
        var collections = flock.favorites.service.getFavoriteCollections( gSelection['url'] );

        while (collections.hasMoreElements()) {
            var collection = flock.favorites.getCollection(collections.getNext());
            XXX('favorite collection has ', collection.resource.Value );
            document.getElementById(collection.resource.Value).firstChild.setAttribute('checked', true);
        }
    }
    else {
        $('collection-list').setAttribute('hidden', true);
        $('favNameBox').setAttribute('hidden', true);
    }

    OriginalData.remember();
    $('favName').focus();
    $('favName').select();
}

var OriginalData = {
    hasChanged: function(aID) {
        if($(aID).nodeName=="checkbox") {
            if(this[aID]==$(aID).checked) return false;
        }
        else {
            if(this[aID]==$(aID).value) return false;
        }
        //dump("has changed " + aID + " " + this[aID] + " " + $(aID).value + "\n");
        return true;
    },
    remember: function() {
        this.favUrl = $('favUrl').value;
        this.favName = $('favName').value;
        this.favTags = $('favTags').value;
        this.favDescription = $('favDescription').value;
        this.postOnline = $('postOnline').checked;
        this.shareLevel = $('shareLevel').value;
    },
}

// XXX collections need to become a reusable binding so we can 
// do things like collections.value and put it anywhere ala tagbox - ja

function flock_favoritesEditorAccept() {
    XXX('need to do validation by using flock.dialog instead');
    
    var rv={}
    // XXX andy: hack to fix empty tags for now this whole thing nees a
    //           proper validation solution and I am not feeling too
    //           excited about implementing another one-off.
    var favTagsValue = $('favTags').value.replace(/\s+|\s$/, "");
    //           back to your regularly scheduled programming

    if (OriginalData.hasChanged('favUrl')) rv.url = $('favUrl').value;
    if (OriginalData.hasChanged('favName')) rv.name = $('favName').value;
    if (OriginalData.hasChanged('favDescription')) rv.description = $('favDescription').value;
    if (OriginalData.hasChanged('favTags')) {
        rv.tags = favTagsValue;
        $('favTags').commitFormHistory();
    }
    if (OriginalData.hasChanged('postOnline')) rv.local = !$('postOnline').checked;
    if (OriginalData.hasChanged('shareLevel')) rv.private = ($('shareLevel').value == 'private');

    // XXX disabling collections if more than one item
    if (params.item) {
        rv.collections = [];
        var collections = document.getElementById('collections').getElementsByTagName('hbox');
        for (var i=0; i<collections.length; i++) {
            if (collections[i].firstChild.checked) {
                XXX('favorite collect is now:', collections[i].id );
                rv.collections.push( collections[i].id );
            }
        }
    }
    
    params.rv = rv;
}

function flock_toggleCollectionCheckbox(aTarget) {
    if (aTarget.parentNode.firstChild.localName == 'checkbox') {
        aTarget.parentNode.firstChild.checked = !aTarget.parentNode.firstChild.checked;
    }
}
